> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.paradex.trade/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.paradex.trade/_mcp/server.

# Get vault historical data

GET https://api.testnet.paradex.trade/v1/vaults/history

Get PnL and Account value historical timeseries for the given vault.


Reference: https://docs.paradex.trade/api/prod/vaults/get-historical-data

## Request

### Query parameters

- `address` (string, required) — Vault Address
- `strategy` (string, optional) — Vault Strategy Address
- `type` (enum, required) — Type of data
  - Allowed values: `pnl`, `value`, `price`
- `resolution` (enum, required) — Resolution of data
  - Allowed values: `alltime`, `1h`, `8h`

## Response

### 200

OK

- `results` (list of responses.VaultHistoricalDataResp, optional) — Array of results

## Errors

### 400 Bad Request Error

Bad Request

- `data` (ResponsesApiErrorData, optional) — any additional data related to the error
- `error` (enum, optional) — unique immutable string identifier for specific error
  - Allowed values: `VALIDATION_ERROR`, `BINDING_ERROR`, `INTERNAL_ERROR`, `NOT_FOUND`, `SERVICE_UNAVAILABLE`, `INVALID_REQUEST_PARAMETER`, `ORDER_ID_NOT_FOUND`, `ORDER_IS_CLOSED`, `ORDER_IS_NOT_OPEN`, `INVALID_ORDER_SIZE`, `CLIENT_ORDER_ID_NOT_FOUND`, `DUPLICATED_CLIENT_ID`, `INVALID_PRICE_PRECISION`, `INVALID_SYMBOL`, `INVALID_TOKEN`, `INVALID_ETHEREUM_ADDRESS`, `INVALID_ETHEREUM_SIGNATURE`, `INVALID_STARKNET_ADDRESS`, `INVALID_STARKNET_SIGNATURE`, `STARKNET_SIGNATURE_VERIFICATION_FAILED`, `BAD_STARKNET_REQUEST`, `ETHEREUM_SIGNER_MISMATCH`, `ETHEREUM_HASH_MISMATCH`, `NOT_ONBOARDED`, `INVALID_TIMESTAMP`, `INVALID_BLOCK_EXPIRATION`, `ACCOUNT_NOT_FOUND`, `INVALID_ORDER_SIGNATURE`, `PUBLIC_KEY_INVALID`, `UNAUTHORIZED_ETHEREUM_ADDRESS`, `UNAUTHORIZED_ERROR`, `ETHEREUM_ADDRESS_ALREADY_ONBOARDED`, `MARKET_NOT_FOUND`, `ALLOWLIST_ENTRY_NOT_FOUND`, `USERNAME_IN_USE`, `GEO_IP_BLOCK`, `ETHEREUM_ADDRESS_BLOCKED`, `PROGRAM_NOT_FOUND`, `PROGRAM_NOT_SUPPORTED`, `INVALID_DASHBOARD`, `MARKET_NOT_OPEN`, `INVALID_REFERRAL_CODE`, `REQUEST_NOT_ALLOWED`, `PARENT_ADDRESS_ALREADY_ONBOARDED`, `INVALID_PARENT_ACCOUNT`, `INVALID_VAULT_OPERATOR_CHAIN`, `VAULT_OPERATOR_ALREADY_ONBOARDED`, `VAULT_NAME_IN_USE`, `VAULT_NOT_FOUND`, `VAULT_STRATEGY_NOT_FOUND`, `VAULT_LIMIT_REACHED`, `BATCH_SIZE_OUT_OF_RANGE`, `ISOLATED_MARKET_ACCOUNT_MISMATCH`, `NO_ACCESS_TO_MARKET`, `POINTS_SUMMARY_NOT_FOUND`, `ALGO_ID_NOT_FOUND`, `INVALID_DERIVATION_PATH`, `PROFILE_STATS_NOT_FOUND`, `INVALID_CHAIN`, `INVALID_LAYERSWAP_SWAP`, `INVALID_RHINOFI_REQUEST`, `INVALID_RHINOFI_QUOTE`, `INVALID_RHINOFI_QUOTE_COMMIT`, `SOCIAL_USERNAME_IN_USE`, `INVALID_OAUTH_REQUEST`, `RPI_ACCOUNT_NOT_WHITELISTED`, `SYSTEM_STATUS_POST_ONLY`, `SYSTEM_STATUS_CANCEL_ONLY`, `INVALID_MARKETING_CODE`, `INVALID_JOIN_WAITLIST_REQUEST`, `TRANSACTION_NOT_FOUND`, `OFFER_NOT_FOUND`, `MARKET_MARGIN_RESTRICTED`, `NOT_UNIQUE`, `ACCOUNT_ALREADY_REFERRED`, `ONBOARDING_PERIOD_EXPIRED`, `ONBOARDING_RATE_LIMITED`, `SUBACCOUNTS_LIMIT_EXCEEDED`, `INSUFFICIENT_MIN_CHAIN_BALANCE`, `INVALID_SUBKEY`, `TOKEN_LIMIT_REACHED`, `INVALID_TOKEN_SCOPE`, `INSUFFICIENT_TRANSFERRABLE_XP`, `TRANSFER_LIMIT_REACHED`
- `message` (string, optional) — detailed description of error and how to address it

## Types

### responses.VaultHistoricalDataResp

- `address` (string, optional) — Contract address of the vault
- `data` (list of double, optional) — Ordered list of datapoints
- `timestamps` (list of integer, optional) — Ordered list of timestamps

### ResponsesApiErrorData

any additional data related to the error

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "results": [
    {
      "address": "0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2",
      "data": [
        0.05,
        0.12,
        -0.03,
        0.07,
        0.1
      ],
      "timestamps": [
        1685606400,
        1685610000,
        1685613600,
        1685617200,
        1685620800
      ]
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.testnet.paradex.trade/v1/vaults/history"

querystring = {"address":"0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2","type":"pnl","resolution":"1h","strategy":"0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed"}

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.get(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.testnet.paradex.trade/v1/vaults/history?address=0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2&type=pnl&resolution=1h&strategy=0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed';
const options = {method: 'GET', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.testnet.paradex.trade/v1/vaults/history?address=0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2&type=pnl&resolution=1h&strategy=0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.testnet.paradex.trade/v1/vaults/history?address=0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2&type=pnl&resolution=1h&strategy=0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.testnet.paradex.trade/v1/vaults/history?address=0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2&type=pnl&resolution=1h&strategy=0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.testnet.paradex.trade/v1/vaults/history?address=0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2&type=pnl&resolution=1h&strategy=0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.testnet.paradex.trade/v1/vaults/history?address=0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2&type=pnl&resolution=1h&strategy=0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed");
var request = new RestRequest(Method.GET);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.testnet.paradex.trade/v1/vaults/history?address=0x9f8F72aa9304c8B593d555F12eF6589cC3A579A2&type=pnl&resolution=1h&strategy=0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```